VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5385
   ClientLeft      =   660
   ClientTop       =   600
   ClientWidth     =   3840
   LinkTopic       =   "Form1"
   PaletteMode     =   1  'UseZOrder
   ScaleHeight     =   5385
   ScaleWidth      =   3840
   Begin VB.Timer tmrKeyMover 
      Left            =   1680
      Top             =   1080
   End
   Begin VB.PictureBox picHidden 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   5325
      Left            =   1800
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   355
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   251
      TabIndex        =   3
      Top             =   2400
      Visible         =   0   'False
      Width           =   3765
   End
   Begin VB.PictureBox picXMask 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1605
      Left            =   2280
      Picture         =   "Form1.frx":8301
      ScaleHeight     =   107
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   91
      TabIndex        =   1
      Top             =   1800
      Visible         =   0   'False
      Width           =   1365
   End
   Begin VB.PictureBox picX 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      BorderStyle     =   0  'None
      Height          =   1605
      Left            =   2760
      Picture         =   "Form1.frx":F69F
      ScaleHeight     =   107
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   91
      TabIndex        =   0
      Top             =   1320
      Visible         =   0   'False
      Width           =   1365
   End
   Begin VB.PictureBox picCanvas 
      AutoRedraw      =   -1  'True
      AutoSize        =   -1  'True
      Height          =   5385
      Left            =   0
      Picture         =   "Form1.frx":16A3D
      ScaleHeight     =   355
      ScaleMode       =   3  'Pixel
      ScaleWidth      =   251
      TabIndex        =   2
      Top             =   0
      Width           =   3825
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Const MERGEPAINT = &HBB0226
Private Const SRCAND = &H8800C6
Private Const SRCCOPY = &HCC0020
Private Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal x As Long, ByVal y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

'    
Dim OldX As Single
Dim OldY As Single
Dim CurX As Single
Dim CurY As Single
Dim OffsetX As Single
Dim OffsetY As Single
Dim PicWid As Single
Dim PicHgt As Single
Dim Xmax As Single
Dim Ymax As Single
Dim Dragging As Boolean

'    
Private m_Dx As Integer
Private m_Dy As Integer
'     (CurX, CurY).
Private Sub DrawPicture()
    '   
    BitBlt picCanvas.hDC, _
        OldX, OldY, PicWid, PicHgt, _
        picHidden.hDC, OldX, OldY, SRCCOPY
    OldX = CurX
    OldY = CurY

    '    
    BitBlt picCanvas.hDC, _
        CurX, CurY, PicWid, PicHgt, _
        picXMask.hDC, 0, 0, MERGEPAINT
    BitBlt picCanvas.hDC, _
        CurX, CurY, PicWid, PicHgt, _
        picX.hDC, 0, 0, SRCAND

    '  
    picCanvas.Refresh
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyLeft
            m_Dx = -5
        Case vbKeyRight
            m_Dx = 5
        Case vbKeyUp
            m_Dy = -5
        Case vbKeyDown
            m_Dy = 5
    End Select

    tmrKeyMover.Enabled = (m_Dx <> 0) Or (m_Dy <> 0)
End Sub

Private Sub Form_KeyUp(KeyCode As Integer, Shift As Integer)
    Select Case KeyCode
        Case vbKeyLeft, vbKeyRight
            m_Dx = 0
        Case vbKeyUp, vbKeyDown
            m_Dy = 0
    End Select

    tmrKeyMover.Enabled = (m_Dx <> 0) Or (m_Dy <> 0)
End Sub


' Save picCanvas's original bitmap bytes,
' initialize values, and draw the initial picture.
Private Sub Form_Load()
    KeyPreview = True
    tmrKeyMover.Interval = 10
    tmrKeyMover.Enabled = False

    ' Make the form fit the picture.
    Width = (Width - ScaleWidth) + picCanvas.Width
    Height = (Height - ScaleHeight) + picCanvas.Height

    PicWid = picX.ScaleWidth
    PicHgt = picX.ScaleHeight
    Xmax = picCanvas.ScaleWidth - PicWid
    Ymax = picCanvas.ScaleHeight - PicHgt
    OldX = 30
    OldY = 30
    CurX = 30
    CurY = 30
    
    DrawPicture
End Sub

Private Sub picCanvas_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
    ' See if this point corresponds to
    ' a black point on the mask.
    If picXMask.Point(x - CurX, y - CurY) <> vbBlack Then Exit Sub

    ' Start dragging.
    Dragging = True
    OffsetX = CurX - x
    OffsetY = CurY - y
End Sub

' Continue dragging.
Private Sub picCanvas_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
    If Not Dragging Then Exit Sub
    
    CurX = x + OffsetX
    CurY = y + OffsetY

    If CurX < 0 Then CurX = 0
    If CurX > Xmax Then CurX = Xmax
    If CurY < 0 Then CurY = 0
    If CurY > Ymax Then CurY = Ymax

    DrawPicture
End Sub


' Stop dragging.
Private Sub picCanvas_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
    Dragging = False
End Sub

Private Sub tmrKeyMover_Timer()
    CurX = CurX + m_Dx
    CurY = CurY + m_Dy

    If CurX < 0 Then CurX = 0
    If CurX > Xmax Then CurX = Xmax
    If CurY < 0 Then CurY = 0
    If CurY > Ymax Then CurY = Ymax

    DrawPicture
End Sub


